=== debian/changelog ===
mlpack (2.0.3-1build1) zesty; urgency=high

  * No change rebuild against boost1.62.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 01 Nov 2016 16:30:52 +0000

mlpack (2.0.3-1) unstable; urgency=medium

  * New upstream version

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 15 Sep 2016 12:00:57 +0100
