## mlpack 2.1.0

=== src/mlpack/tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,20 +1,27 @@
 # mlpack test executable.
 add_executable(mlpack_test
-  mlpack_test.cpp
   adaboost_test.cpp
+  akfn_test.cpp
+  aknn_test.cpp
   arma_extend_test.cpp
+  armadillo_svd_test.cpp
   aug_lagrangian_test.cpp
+  binarize_test.cpp
   cf_test.cpp
   cli_test.cpp
   cosine_tree_test.cpp
   decision_stump_test.cpp
   det_test.cpp
   distribution_test.cpp
+  drusilla_select_test.cpp
   emst_test.cpp
   fastmks_test.cpp
   gmm_test.cpp
+  gradient_descent_test.cpp
   hmm_test.cpp
   hoeffding_tree_test.cpp
+  hyperplane_test.cpp
+  imputation_test.cpp
   ind2sub_test.cpp
   kernel_test.cpp
   kernel_pca_test.cpp
@@ -39,13 +46,18 @@
   mean_shift_test.cpp
   metric_test.cpp
   minibatch_sgd_test.cpp
+  mlpack_test.cpp
   nbc_test.cpp
   nca_test.cpp
   nmf_test.cpp
+  nystroem_method_test.cpp
+  octree_test.cpp
   pca_test.cpp
   perceptron_test.cpp
+  qdafn_test.cpp
   quic_svd_test.cpp
   radical_test.cpp
+  randomized_svd_test.cpp
   range_search_test.cpp
   rectangle_tree_test.cpp
   regularized_svd_test.cpp
@@ -59,7 +71,10 @@
   sort_policy_test.cpp
   sparse_autoencoder_test.cpp
   sparse_coding_test.cpp
+  spill_tree_test.cpp
   split_data_test.cpp
+  svd_batch_test.cpp
+  svd_incremental_test.cpp
   termination_policy_test.cpp
   tree_test.cpp
   tree_traits_test.cpp
@@ -68,6 +83,8 @@
   svd_incremental_test.cpp
   nystroem_method_test.cpp
   armadillo_svd_test.cpp
+  ub_tree_test.cpp
+  vantage_point_tree_test.cpp
 )
 # Link dependencies of test executable.
 target_link_libraries(mlpack_test
