=== debian/changelog ===
mlpack (2.1.0-1ubuntu1) zesty; urgency=medium

  * Set --max-parallel=2 to prevent OOM on Ubuntu buildds.

 -- Graham Inggs <ginggs@ubuntu.com>  Sun, 27 Nov 2016 10:09:01 +0200

mlpack (2.1.0-1) unstable; urgency=medium

  * Track upstream changes, including pkg-config goo desired by Dirk for R
  * Tweak build scripts to generate/install .pc file
  * Use jquery.js from common package per lintian whining
  * New upstream version
  * Remove now-unnecessary cmake hardening workaround
  * bump to dh10

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 14 Nov 2016 14:38:59 +0000
