=== debian/control ===
--- 
+++ 
@@ -4,7 +4,8 @@
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Barak A. Pearlmutter <bap@debian.org>
-Build-Depends: cmake, debhelper (>=9), dh-exec,
+Build-Depends: cmake, debhelper (>= 10), dh-exec,
+		pkg-config,
 		libboost-math-dev,
 		libboost-program-options-dev,
 		libboost-random-dev,
@@ -68,7 +69,7 @@
 Section: doc
 Architecture: all
 Pre-Depends: ${misc:Pre-Depends}
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}, libjs-jquery
 Description: intuitive, fast, scalable C++ machine learning library (documentation)
  This package contains documentation for the mlpack Library.
  .
