=== debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --max-parallel=2

override_dh_auto_build:
	dh_auto_build
	@echo building PDF reference manual
	cd obj-*/doc/latex && \
	 sed --in-place 's:usepackage\[utf8\]{inputenc}:usepackage[utf8x]{inputenc}:' refman.tex && \
	 $(MAKE) pdf

override_dh_auto_test:
	@echo do not ask do not tell do not test

override_dh_install:
	dh_install --list-missing
	for f in $$(find debian/mlpack-doc -name jquery.js); do \
	  ln -sf /usr/share/javascript/jquery/jquery.js $$f; \
	done

override_dh_compress:
	dh_compress -Xrefman.pdf -Xdoc/html/
